# Develop KubeVela with VelaD

It's easy to use VelaD to get a local KubeVela development environment. This document will show you how to create a 
KubeVela controller (vela-core) development environment.


## Prerequisites

1. No need for preparing a cluster. VelaD will take care of the cluster. 
2. Other tools you need is listed in [contribution guide](https://kubevela.io/docs/contributor/code-contribute#prerequisites). 

> Note the second item "Kubernetes ..." is NOT needed.
> If you want to use cluster already exist as develop environment, please check [this doc](https://kubevela.io/docs/contributor/code-contribute#prerequisites) directly
 
3. Docker (If you are using macOS or Windows)


## Steps

1. Setup Cluster and Helm Chart 
```shell
velad install --set admissionWebhooks.enabled=false --set replicaCount=0
```
This command setup k3d/k3s cluster and install vela-core with no running controller.

2. Run Vela Core
```shell
export KUBECONFIG=$(velad kubeconfig --host)
make core-run
```
This command will run KubeVela controller locally. There you go! you already have a KubeVela
development environment.

## Summary

This guide shows how to create a KubeVela development environment and run KubeVela locally.
For further guide (Testing, Create a PR, Formatting guide...), please return to [contribution guide](https://kubevela.io/docs/contributor/code-contribute#prerequisites)